#ifndef __fsys_h__
#define __fsys_h__

#include <stdio.h>

#define	SEEK_SET 0
#define	SEEK_CUR 1
#define	SEEK_END 2

typedef void FSYS_FILE;

extern FSYS_FILE* fsys_fopen(const char*, const char*);
extern int        fsys_fread(void*, size_t, size_t, FSYS_FILE*);
extern int        fsys_fclose(FSYS_FILE*);
extern int        fsys_fseek(FSYS_FILE*, long int, int);
extern long int   fsys_ftell(FSYS_FILE*);
extern int        fsys_ferror(FSYS_FILE*);
extern int        fsys_feof(FSYS_FILE*);
extern int        fsys_fwrite(const void*, size_t, size_t, FSYS_FILE*);

extern int        fsys_remove(const char*);

/* Code by Harteex */

typedef struct {
	unsigned int  handle;
	unsigned int  size;
	unsigned int  attributes;
	unsigned int  time;
	short         padding;
	char          filename[544];
} findData;

/* 
 * findfirst(path + *, flags, result).
 * All below returns 0 on match / success, otherwise < 0
 */
extern int        fsys_findfirst(const char*, int, findData*);
extern int        fsys_findnext(findData*);
extern int        fsys_findclose(findData*);

#endif
