#include <string.h>
#include <stdint.h>

int _strlen(const char* inStr) {
	uintptr_t i;
	for(i = 0; inStr[i] != '\0'; i++);
	return i;
}

/* public domain from http://en.wikibooks.org/wiki/C_Programming/Strings
"char* restrict s" changed to "char* s" because I don't know what restrict is */
char *(strcat)(char* s1, const char* s2) {
	char *s = s1;
	// Move s so that it points to the end of s1.
	while (*s != '\0')
		s++;
	// Copy the contents of s2 into the space at the end of s1.
	strcpy(s, s2);
	return s1;
 }

char* strcpy(char* outDest, const char* inSrc) {
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;
	size_t i;
	for(i = 0; inSrc[i] != '\0'; i++)
		outDest[i] = inSrc[i];
	outDest[i] = '\0';
	return outDest;
}

char* strncpy(char* outDest, const char* inSrc, size_t inLength) {
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;
	size_t i;
	for(i = 0; (inSrc[i] != '\0') && (i < inLength); i++)
		outDest[i] = inSrc[i];
	outDest[i] = '\0';
	return outDest;
}

int strcmp(const char* inStr0, const char* inStr1) {
	if(inStr0 == NULL) {
		if(inStr1 == NULL)
			return 0;
		return -inStr1[0];
	}
	if(inStr1 == NULL)
		return (unsigned char)inStr0[0];
	uintptr_t i;
	for(i = 0; (inStr0[i] != '\0') || (inStr1[i] != '\0'); i++) {
		if(inStr0[i] != inStr1[i])
			return (inStr0[i] - inStr1[i]);
	}
	return 0;
}

int strncmp(const char* inStr0, const char* inStr1, size_t inLength) {
	if(inStr0 == NULL) {
		if(inStr1 == NULL)
			return 0;
		return -inStr1[0];
	}
	if(inStr1 == NULL)
		return (unsigned char)inStr0[0];
	uintptr_t i;
	for(i = 0; (i < inLength) && ((inStr0[i] != '\0') || (inStr1[i] != '\0')); i++) {
		if(inStr0[i] != inStr1[i])
			return (inStr0[i] - inStr1[i]);
	}
	return 0;
}



void* memcpy(void* outDest, const void* inSrc, size_t inLength) {
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;
	size_t i;
	for(i = 0; i < inLength; i++)
		((uint8_t*)outDest)[i] = ((uint8_t*)inSrc)[i];
	// TODO - Optimize.
	return outDest;
}

void* memmove(void* outDest, const void* inSrc, size_t inLength) {
	if((uintptr_t)outDest < (uintptr_t)inSrc)
		return memcpy(outDest, inSrc, inLength);
	if((uintptr_t)outDest >= ((uintptr_t)inSrc + inLength))
		return memcpy(outDest, inSrc, inLength);
	size_t i;
	for(i = (inLength - 1); (i + 1) != 0; i--)
		((uint8_t*)outDest)[i] = ((uint8_t*)inSrc)[i];
	// TODO - Optimize, make memcpy do memmove anyway and just make this a wrapper of memcpy.
	return outDest;
}

void* memset(void* outDest, int inValue, size_t inLength) {
	if(outDest == NULL)
		return NULL;
	if((inValue >= 256) || (inValue < -128))
		return NULL;
	size_t i;
	for(i = 0; i < inLength; i++)
		((uint8_t*)outDest)[i] = (uint8_t)inValue;
	// TODO - Optimize.
	return outDest;
}

/* public domain from http://en.wikibooks.org/wiki/C_Programming/Strings */
 int (memcmp)(const void *s1, const void *s2, size_t n)
 {
     const unsigned char *us1 = (const unsigned char *) s1;
     const unsigned char *us2 = (const unsigned char *) s2;
     while (n-- != 0) {
         if (*us1 != *us2)
             return (*us1 < *us2) ? -1 : +1;
         us1++;
         us2++;
     }
     return 0;
 }

/* public domain from http://en.wikibooks.org/wiki/C_Programming/Strings#The_memchr_function */
void *(memchr)(const void *s, int c, size_t n){
	const unsigned char *src = s;
	unsigned char uc = c;
	while (n-- != 0) {
		if (*src == uc)
			return (void *) src;
		src++;
	}
	return NULL;
 }
